Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.jetty.server
Class Request

    java.lang.Object
      org.eclipse.jetty.server.Request

All Implemented Interfaces:
  HttpServletRequest, ServletRequest

Direct Known Subclasses:
  Ajp13Request

    public class Request

extends java.lang.Object
implements HttpServletRequest

Jetty Request.

Implements `HttpServletRequest` from the `javax.servlet.http` package.

The standard interface of mostly getters, is extended with setters so that the request is mutable by the handlers that it is passed to. This allows the request object to be as lightweight as possible and not actually implement any significant behavior. For example

- The `getContextPath()` method will return null, until the request has been passed to a `ContextHandler` which matches the `getPathInfo()` with a context path and calls `setContextPath(String)` as a result.
- the HTTP session methods will all return null sessions until such time as a request has been passed to a `SessionHandler` which checks for session cookies and enables the ability to create new sessions.
- The `getServletPath()` method will return null until the request has been passed to a `org.eclipse.jetty.servlet.ServletHandler` and the pathInfo matched against the servlet URL patterns and `setServletPath(String)` called as a result.

A request instance is created for each `HttpConnection` accepted by the server and recycled for each HTTP request received via that connection. An effort is made to avoid reparsing headers and cookies that are likely to be the same for requests from the same connection.

Field Summary
`static java.lang.String` | `__MULTIPART_CONFIG_ELEMENT`
`protected AsyncContinuation` | `_async`
`protected HttpConnection` | `_connection`

Fields inherited from interface javax.servlet.http.HttpServletRequest
`BASIC_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH, FORM_AUTH`

Constructor Summary
`Request()`
`Request(HttpConnection connection)`

Method Summary
`void` | `addEventListener(java.util.EventListener listener)`
`boolean` | `authenticate(HttpServletResponse response)` Use the container login mechanism configured for the `ServletContext` to authenticate the user making this request.
`void` | `extractParameters()` Extract Paramters from query string and/or form _content.
`AsyncContext` | `getAsyncContext()` Gets the AsyncContext that was created or reinitialized by the most recent invocation of `ServletRequest.startAsync()` or `ServletRequest.startAsync(ServletRequest,ServletResponse)` on this request.
`AsyncContinuation` | `getAsyncContinuation()`
`java.lang.Object` | `getAttribute(java.lang.String name)` Returns the value of the named attribute as an `Object`, or `null` if no attribute of the given name exists.
`java.util.Enumeration` | `getAttributeNames()` Returns an `Enumeration` containing the names of the attributes available to this request.
`Attributes` | `getAttributes()`
`Authentication` | `getAuthentication()` Get the authentication.
`java.lang.String` | `getAuthType()` Returns the name of the authentication scheme used to protect the servlet.
`java.lang.String` | `getCharacterEncoding()` Returns the name of the character encoding used in the body of this request.
`HttpConnection` | `getConnection()`
`int` | `getContentLength()` Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known.
`long` | `getContentRead()`
`java.lang.String` | `getContentType()` Returns the MIME type of the body of the request, or `null` if the type is not known.
`ContextHandler.Context` | `getContext()`
`java.lang.String` | `getContextPath()` Returns the portion of the request URI that indicates the context of the request.
`Cookie[]` | `getCookies()` Returns an array containing all of the `Cookie` objects the client sent with this request.
`long` | `getDateHeader(java.lang.String name)` Returns the value of the specified request header as a `long` value that represents a `Date` object.
`DispatcherType` | `getDispatcherType()` Gets the dispatcher type of this request.
`long` | `getDispatchTime()` Get timestamp of the request dispatch
`java.lang.String` | `getHeader(java.lang.String name)` Returns the value of the specified request header as a `String`.
`java.util.Enumeration` | `getHeaderNames()` Returns an enumeration of all the header names this request contains.
`java.util.Enumeration` | `getHeaders(java.lang.String name)` Returns all the values of the specified request header as an `Enumeration` of `String` objects.
`int` | `getInputState()`
`ServletInputStream` | `getInputStream()` Retrieves the body of the request as binary data using a `ServletInputStream`.
`int` | `getIntHeader(java.lang.String name)` Returns the value of the specified request header as an `int`.
`java.lang.String` | `getLocalAddr()` Returns the Internet Protocol (IP) address of the interface on which the request was received.
`java.util.Locale` | `getLocale()` Returns the preferred `Locale` that the client will accept content in, based on the Accept-Language header.
`java.util.Enumeration` | `getLocales()` Returns an `Enumeration` of `Locale` objects indicating, in decreasing order starting with the preferred locale, the locales that are acceptable to the client based on the Accept-Language header.
`java.lang.String` | `getLocalName()` Returns the host name of the Internet Protocol (IP) interface on which the request was received.
`int` | `getLocalPort()` Returns the Internet Protocol (IP) port number of the interface on which the request was received.
`java.lang.String` | `getMethod()` Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT.
`java.lang.String` | `getParameter(java.lang.String name)` Returns the value of a request parameter as a `String`, or `null` if the parameter does not exist.
`java.util.Map` | `getParameterMap()` Returns a java.util.Map of the parameters of this request.
`java.util.Enumeration` | `getParameterNames()` Returns an `Enumeration` of `String` objects containing the names of the parameters contained in this request.
`MultiMap<java.lang.String>` | `getParameters()`
`java.lang.String[]` | `getParameterValues(java.lang.String name)` Returns an array of `String` objects containing all of the values the given request parameter has, or `null` if the parameter does not exist.
`Part` | `getPart(java.lang.String name)` Gets the `Part` with the given name.
`java.util.Collection<Part>` | `getParts()` Gets all the `Part` components of this request, provided that it is of type `multipart/form-data`.
`java.lang.String` | `getPathInfo()` Returns any extra path information associated with the URL the client sent when it made this request.
`java.lang.String` | `getPathTranslated()` Returns any extra path information after the servlet name but before the query string, and translates it to a real path.
`java.lang.String` | `getProtocol()` Returns the name and version of the protocol the request uses in the form protocol/majorVersion.minorVersion, for example, HTTP/1.1.
`java.lang.String` | `getQueryEncoding()`
`java.lang.String` | `getQueryString()` Returns the query string that is contained in the request URL after the path.
`java.io.BufferedReader` | `getReader()` Retrieves the body of the request as character data using a `BufferedReader`.
`java.lang.String` | `getRealPath(java.lang.String path)`
`java.lang.String` | `getRemoteAddr()` Returns the Internet Protocol (IP) address of the client or last proxy that sent the request.
`java.lang.String` | `getRemoteHost()` Returns the fully qualified name of the client or the last proxy that sent the request.
`int` | `getRemotePort()` Returns the Internet Protocol (IP) source port of the client or last proxy that sent the request.
`java.lang.String` | `getRemoteUser()` Returns the login of the user making this request, if the user has been authenticated, or `null` if the user has not been authenticated.
`static Request` | `getRequest(HttpServletRequest request)`
`RequestDispatcher` | `getRequestDispatcher(java.lang.String path)` Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path.
`java.lang.String` | `getRequestedSessionId()` Returns the session ID specified by the client.
`java.lang.String` | `getRequestURI()` Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request.
`java.lang.StringBuffer` | `getRequestURL()` Reconstructs the URL the client used to make the request.
`UserIdentity` | `getResolvedUserIdentity()`
`Response` | `getResponse()`
`java.lang.StringBuilder` | `getRootURL()` Reconstructs the URL the client used to make the request.
`java.lang.String` | `getScheme()` Returns the name of the scheme used to make this request, for example, `http`, `https`, or `ftp`.
`java.lang.String` | `getServerName()` Returns the host name of the server to which the request was sent.
`int` | `getServerPort()` Returns the port number to which the request was sent.
`ServletContext` | `getServletContext()` Gets the servlet context to which this ServletRequest was last dispatched.
`java.lang.String` | `getServletName()`
`java.lang.String` | `getServletPath()` Returns the part of this request's URL that calls the servlet.
`ServletResponse` | `getServletResponse()`
`HttpSession` | `getSession()` Returns the current session associated with this request, or if the request does not have a session, creates one.
`HttpSession` | `getSession(boolean create)` Returns the current `HttpSession` associated with this request or, if there is no current session and `create` is true, returns a new session.
`SessionManager` | `getSessionManager()`
`long` | `getTimeStamp()` Get Request TimeStamp
`Buffer` | `getTimeStampBuffer()` Get Request TimeStamp
`HttpURI` | `getUri()`
`UserIdentity` | `getUserIdentity()`
`UserIdentity.Scope` | `getUserIdentityScope()`
`java.security.Principal` | `getUserPrincipal()` Returns a `java.security.Principal` object containing the name of the current authenticated user.
`boolean` | `isAsyncStarted()` Checks if this request has been put into asynchronous mode.
`boolean` | `isAsyncSupported()` Checks if this request supports asynchronous operation.
`boolean` | `isHandled()`
`boolean` | `isRequestedSessionIdFromCookie()` Checks whether the requested session ID came in as a cookie.
`boolean` | `isRequestedSessionIdFromUrl()`
`boolean` | `isRequestedSessionIdFromURL()` Checks whether the requested session ID came in as part of the request URL.
`boolean` | `isRequestedSessionIdValid()` Checks whether the requested session ID is still valid.
`boolean` | `isSecure()` Returns a boolean indicating whether this request was made using a secure channel, such as HTTPS.
`boolean` | `isUserInRole(java.lang.String role)` Returns a boolean indicating whether the authenticated user is included in the specified logical "role".
`void` | `login(java.lang.String username, java.lang.String password)` Validate the provided username and password in the password validation realm used by the web container login mechanism configured for the `ServletContext`.
`void` | `logout()` Establish `null` as the value returned when `getUserPrincipal`, `getRemoteUser`, and `getAuthType` is called on the request.
`void` | `mergeQueryString(java.lang.String query)` Merge in a new query string.
`HttpSession` | `recoverNewSession(java.lang.Object key)`
`protected void` | `recycle()`
`void` | `removeAttribute(java.lang.String name)` Removes an attribute from this request.
`void` | `removeEventListener(java.util.EventListener listener)`
`void` | `saveNewSession(java.lang.Object key, HttpSession session)`
`void` | `setAsyncSupported(boolean supported)`
`void` | `setAttribute(java.lang.String name, java.lang.Object value)` Stores an attribute in this request.
`void` | `setAttributes(Attributes attributes)`
`void` | `setAuthentication(Authentication authentication)` Set the authentication.
`void` | `setCharacterEncoding(java.lang.String encoding)` Overrides the name of the character encoding used in the body of this request.
`void` | `setCharacterEncodingUnchecked(java.lang.String encoding)`
`protected void` | `setConnection(HttpConnection connection)`
`void` | `setContentType(java.lang.String contentType)`
`void` | `setContext(ContextHandler.Context context)` Set request context
`void` | `setContextPath(java.lang.String contextPath)` Sets the "context path" for this request
`void` | `setCookies(Cookie[] cookies)`
`void` | `setDispatcherType(DispatcherType type)`
`void` | `setDispatchTime(long value)` Set timetstamp of request dispatch
`void` | `setHandled(boolean h)`
`void` | `setMethod(java.lang.String method)`
`void` | `setParameters(MultiMap<java.lang.String> parameters)`
`void` | `setPathInfo(java.lang.String pathInfo)`
`void` | `setProtocol(java.lang.String protocol)`
`void` | `setQueryEncoding(java.lang.String queryEncoding)` Set the character encoding used for the query string.
`void` | `setQueryString(java.lang.String queryString)`
`void` | `setRemoteAddr(java.lang.String addr)`
`void` | `setRemoteHost(java.lang.String host)`
`void` | `setRequestedSessionId(java.lang.String requestedSessionId)`
`void` | `setRequestedSessionIdFromCookie(boolean requestedSessionIdCookie)`
`void` | `setRequestURI(java.lang.String requestURI)`
`void` | `setScheme(java.lang.String scheme)`
`void` | `setServerName(java.lang.String host)`
`void` | `setServerPort(int port)`
`void` | `setServletPath(java.lang.String servletPath)`
`void` | `setSession(HttpSession session)`
`void` | `setSessionManager(SessionManager sessionManager)`
`void` | `setTimeStamp(long ts)`
`void` | `setUri(HttpURI uri)`
`void` | `setUserIdentityScope(UserIdentity.Scope scope)`
`AsyncContext` | `startAsync()` Puts this request into asynchronous mode, and initializes its `AsyncContext` with the original (unwrapped) ServletRequest and ServletResponse objects.
`AsyncContext` | `startAsync(ServletRequest servletRequest, ServletResponse servletResponse)` Puts this request into asynchronous mode, and initializes its `AsyncContext` with the given request and response objects.
`boolean` | `takeNewContext()`
`java.lang.String` | `toString()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### __MULTIPART_CONFIG_ELEMENT

    public static final java.lang.String __MULTIPART_CONFIG_ELEMENT

See Also:
  Constant Field Values

### _async

    protected final AsyncContinuation _async

### _connection

    protected HttpConnection _connection

Constructor Detail

### Request

    public Request()

### Request

    public Request(HttpConnection connection)

Method Detail

### getRequest

    public static Request getRequest(HttpServletRequest request)

### addEventListener

    public void addEventListener(java.util.EventListener listener)

### extractParameters

    public void extractParameters()

  Extract Paramters from query string and/or form _content.

### getAsyncContext

    public AsyncContext getAsyncContext()

  Description copied from interface: `ServletRequest`
  Gets the AsyncContext that was created or reinitialized by the most recent invocation of `ServletRequest.startAsync()` or `ServletRequest.startAsync(ServletRequest,ServletResponse)` on this request.

  Specified by:
    `getAsyncContext` in interface `ServletRequest`
  Returns:
    the AsyncContext that was created or reinitialized by the most recent invocation of `ServletRequest.startAsync()` or `ServletRequest.startAsync(ServletRequest,ServletResponse)` on this request

### getAsyncContinuation

    public AsyncContinuation getAsyncContinuation()

### getAttribute

    public java.lang.Object getAttribute(java.lang.String name)

  Description copied from interface: `ServletRequest`
  Returns the value of the named attribute as an `Object`, or `null` if no attribute of the given name exists.

  Attributes can be set two ways. The servlet container may set attributes to make available custom information about a request. For example, for requests made using HTTPS, the attribute `javax.servlet.request.X509Certificate` can be used to retrieve information on the certificate of the client. Attributes can also be set programatically using `ServletRequest.setAttribute(java.lang.String, java.lang.Object)`. This allows information to be embedded into a request before a `RequestDispatcher` call.

  Attribute names should follow the same conventions as package names. This specification reserves names matching `java.*`, `javax.*`, and `sun.*`.

  Specified by:
    `getAttribute` in interface `ServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the attribute
  Returns:
    an `Object` containing the value of the attribute, or `null` if the attribute does not exist

### getAttributeNames

    public java.util.Enumeration getAttributeNames()

  Description copied from interface: `ServletRequest`
  Returns an `Enumeration` containing the names of the attributes available to this request. This method returns an empty `Enumeration` if the request has no attributes available to it.

  Specified by:
    `getAttributeNames` in interface `ServletRequest`
  Returns:
    an `Enumeration` of strings containing the names of the request's attributes

### getAttributes

    public Attributes getAttributes()

### getAuthentication

    public Authentication getAuthentication()

  Get the authentication.

  Returns:
    the authentication

### getAuthType

    public java.lang.String getAuthType()

  Description copied from interface: `HttpServletRequest`
  Returns the name of the authentication scheme used to protect the servlet. All servlet containers support basic, form and client certificate authentication, and may additionally support digest authentication. If the servlet is not authenticated `null` is returned.

  Same as the value of the CGI variable AUTH_TYPE.

  Specified by:
    `getAuthType` in interface `HttpServletRequest`
  Returns:
    one of the static members BASIC_AUTH, FORM_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH (suitable for == comparison) or the container-specific string indicating the authentication scheme, or `null` if the request was not authenticated.

### getCharacterEncoding

    public java.lang.String getCharacterEncoding()

  Description copied from interface: `ServletRequest`
  Returns the name of the character encoding used in the body of this request. This method returns `null` if the request does not specify a character encoding

  Specified by:
    `getCharacterEncoding` in interface `ServletRequest`
  Returns:
    a `String` containing the name of the character encoding, or `null` if the request does not specify a character encoding

### getConnection

    public HttpConnection getConnection()

  Returns:
    Returns the connection.

### getContentLength

    public int getContentLength()

  Description copied from interface: `ServletRequest`
  Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_LENGTH.

  Specified by:
    `getContentLength` in interface `ServletRequest`
  Returns:
    an integer containing the length of the request body or -1 if the length is not known

### getContentRead

    public long getContentRead()

### getContentType

    public java.lang.String getContentType()

  Description copied from interface: `ServletRequest`
  Returns the MIME type of the body of the request, or `null` if the type is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_TYPE.

  Specified by:
    `getContentType` in interface `ServletRequest`
  Returns:
    a `String` containing the name of the MIME type of the request, or null if the type is not known

### getContext

    public ContextHandler.Context getContext()

  Returns:
    The current `context` used for this request, or `null` if `setContext(org.eclipse.jetty.server.handler.ContextHandler.Context)` has not yet been called.

### getContextPath

    public java.lang.String getContextPath()

  Description copied from interface: `HttpServletRequest`
  Returns the portion of the request URI that indicates the context of the request. The context path always comes first in a request URI. The path starts with a "/" character but does not end with a "/" character. For servlets in the default (root) context, this method returns "". The container does not decode this string.

  It is possible that a servlet container may match a context by more than one context path. In such cases this method will return the actual context path used by the request and it may differ from the path returned by the `ServletContext.getContextPath()` method. The context path returned by `ServletContext.getContextPath()` should be considered as the prime or preferred context path of the application.

  Specified by:
    `getContextPath` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the portion of the request URI that indicates the context of the request
  See Also:
    `ServletContext.getContextPath()`

### getCookies

    public Cookie[] getCookies()

  Description copied from interface: `HttpServletRequest`
  Returns an array containing all of the `Cookie` objects the client sent with this request. This method returns `null` if no cookies were sent.

  Specified by:
    `getCookies` in interface `HttpServletRequest`
  Returns:
    an array of all the `Cookies` included with this request, or `null` if the request has no cookies

### getDateHeader

    public long getDateHeader(java.lang.String name)

  Description copied from interface: `HttpServletRequest`
  Returns the value of the specified request header as a `long` value that represents a `Date` object. Use this method with headers that contain dates, such as `If-Modified-Since`.

  The date is returned as the number of milliseconds since January 1, 1970 GMT. The header name is case insensitive.

  If the request did not have a header of the specified name, this method returns -1. If the header can't be converted to a date, the method throws an `IllegalArgumentException`.

  Specified by:
    `getDateHeader` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the header
  Returns:
    a `long` value representing the date specified in the header expressed as the number of milliseconds since January 1, 1970 GMT, or -1 if the named header was not included with the request

### getDispatcherType

    public DispatcherType getDispatcherType()

  Description copied from interface: `ServletRequest`
  Gets the dispatcher type of this request.

  The dispatcher type of a request is used by the container to select the filters that need to be applied to the request: Only filters with matching dispatcher type and url patterns will be applied.

  Allowing a filter that has been configured for multiple dispatcher types to query a request for its dispatcher type allows the filter to process the request differently depending on its dispatcher type.

  The initial dispatcher type of a request is defined as `DispatcherType.REQUEST`. The dispatcher type of a request dispatched via `RequestDispatcher.forward(ServletRequest, ServletResponse)` or `RequestDispatcher.include(ServletRequest, ServletResponse)` is given as `DispatcherType.FORWARD` or `DispatcherType.INCLUDE`, respectively, while the dispatcher type of an asynchronous request dispatched via one of the `AsyncContext.dispatch()` methods is given as `DispatcherType.ASYNC`. Finally, the dispatcher type of a request dispatched to an error page by the container's error handling mechanism is given as `DispatcherType.ERROR`.

  Specified by:
    `getDispatcherType` in interface `ServletRequest`
  Returns:
    the dispatcher type of this request
  See Also:
    `DispatcherType`

### getHeader

    public java.lang.String getHeader(java.lang.String name)

  Description copied from interface: `HttpServletRequest`
  Returns the value of the specified request header as a `String`. If the request did not include a header of the specified name, this method returns `null`. If there are multiple headers with the same name, this method returns the first head in the request. The header name is case insensitive. You can use this method with any request header.

  Specified by:
    `getHeader` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the header name
  Returns:
    a `String` containing the value of the requested header, or `null` if the request does not have a header of that name

### getHeaderNames

    public java.util.Enumeration getHeaderNames()

  Description copied from interface: `HttpServletRequest`
  Returns an enumeration of all the header names this request contains. If the request has no headers, this method returns an empty enumeration.

  Some servlet containers do not allow servlets to access headers using this method, in which case this method returns `null`

  Specified by:
    `getHeaderNames` in interface `HttpServletRequest`
  Returns:
    an enumeration of all the header names sent with this request; if the request has no headers, an empty enumeration; if the servlet container does not allow servlets to use this method, `null`

### getHeaders

    public java.util.Enumeration getHeaders(java.lang.String name)

  Description copied from interface: `HttpServletRequest`
  Returns all the values of the specified request header as an `Enumeration` of `String` objects.

  Some headers, such as `Accept-Language` can be sent by clients as several headers each with a different value rather than sending the header as a comma separated list.

  If the request did not include any headers of the specified name, this method returns an empty `Enumeration`. The header name is case insensitive. You can use this method with any request header.

  Specified by:
    `getHeaders` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the header name
  Returns:
    an `Enumeration` containing the values of the requested header. If the request does not have any headers of that name return an empty enumeration. If the container does not allow access to header information, return null

### getInputState

    public int getInputState()

  Returns:
    Returns the inputState.

### getInputStream

    public ServletInputStream getInputStream()
                                      throws java.io.IOException

  Description copied from interface: `ServletRequest`
  Retrieves the body of the request as binary data using a `ServletInputStream`. Either this method or `ServletRequest.getReader()` may be called to read the body, not both.

  Specified by:
    `getInputStream` in interface `ServletRequest`
  Returns:
    a `ServletInputStream` object containing the body of the request
  Throws:
    `java.io.IOException` - if an input or output exception occurred

### getIntHeader

    public int getIntHeader(java.lang.String name)

  Description copied from interface: `HttpServletRequest`
  Returns the value of the specified request header as an `int`. If the request does not have a header of the specified name, this method returns -1. If the header cannot be converted to an integer, this method throws a `NumberFormatException`.

  The header name is case insensitive.

  Specified by:
    `getIntHeader` in interface `HttpServletRequest`
  Parameters:
    `name` - a `String` specifying the name of a request header
  Returns:
    an integer expressing the value of the request header or -1 if the request doesn't have a header of this name

### getLocalAddr

    public java.lang.String getLocalAddr()

  Description copied from interface: `ServletRequest`
  Returns the Internet Protocol (IP) address of the interface on which the request was received.

  Specified by:
    `getLocalAddr` in interface `ServletRequest`
  Returns:
    a `String` containing the IP address on which the request was received.

### getLocale

    public java.util.Locale getLocale()

  Description copied from interface: `ServletRequest`
  Returns the preferred `Locale` that the client will accept content in, based on the Accept-Language header. If the client request doesn't provide an Accept-Language header, this method returns the default locale for the server.

  Specified by:
    `getLocale` in interface `ServletRequest`
  Returns:
    the preferred `Locale` for the client

### getLocales

    public java.util.Enumeration getLocales()

  Description copied from interface: `ServletRequest`
  Returns an `Enumeration` of `Locale` objects indicating, in decreasing order starting with the preferred locale, the locales that are acceptable to the client based on the Accept-Language header. If the client request doesn't provide an Accept-Language header, this method returns an `Enumeration` containing one `Locale`, the default locale for the server.

  Specified by:
    `getLocales` in interface `ServletRequest`
  Returns:
    an `Enumeration` of preferred `Locale` objects for the client

### getLocalName

    public java.lang.String getLocalName()

  Description copied from interface: `ServletRequest`
  Returns the host name of the Internet Protocol (IP) interface on which the request was received.

  Specified by:
    `getLocalName` in interface `ServletRequest`
  Returns:
    a `String` containing the host name of the IP on which the request was received.

### getLocalPort

    public int getLocalPort()

  Description copied from interface: `ServletRequest`
  Returns the Internet Protocol (IP) port number of the interface on which the request was received.

  Specified by:
    `getLocalPort` in interface `ServletRequest`
  Returns:
    an integer specifying the port number

### getMethod

    public java.lang.String getMethod()

  Description copied from interface: `HttpServletRequest`
  Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT. Same as the value of the CGI variable REQUEST_METHOD.

  Specified by:
    `getMethod` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the name of the method with which this request was made

### getParameter

    public java.lang.String getParameter(java.lang.String name)

  Description copied from interface: `ServletRequest`
  Returns the value of a request parameter as a `String`, or `null` if the parameter does not exist. Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

  You should only use this method when you are sure the parameter has only one value. If the parameter might have more than one value, use `ServletRequest.getParameterValues(java.lang.String)`.

  If you use this method with a multivalued parameter, the value returned is equal to the first value in the array returned by `getParameterValues`.

  If the parameter data was sent in the request body, such as occurs with an HTTP POST request, then reading the body directly via `ServletRequest.getInputStream()` or `ServletRequest.getReader()` can interfere with the execution of this method.

  Specified by:
    `getParameter` in interface `ServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the parameter
  Returns:
    a `String` representing the single value of the parameter
  See Also:
    `ServletRequest.getParameterValues(java.lang.String)`

### getParameterMap

    public java.util.Map getParameterMap()

  Description copied from interface: `ServletRequest`
  Returns a java.util.Map of the parameters of this request.

  Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

  Specified by:
    `getParameterMap` in interface `ServletRequest`
  Returns:
    an immutable java.util.Map containing parameter names as keys and parameter values as map values. The keys in the parameter map are of type String. The values in the parameter map are of type String array.

### getParameterNames

    public java.util.Enumeration getParameterNames()

  Description copied from interface: `ServletRequest`
  Returns an `Enumeration` of `String` objects containing the names of the parameters contained in this request. If the request has no parameters, the method returns an empty `Enumeration`.

  Specified by:
    `getParameterNames` in interface `ServletRequest`
  Returns:
    an `Enumeration` of `String` objects, each `String` containing the name of a request parameter; or an empty `Enumeration` if the request has no parameters

### getParameters

    public MultiMap<java.lang.String> getParameters()

  Returns:
    Returns the parameters.

### getParameterValues

    public java.lang.String[] getParameterValues(java.lang.String name)

  Description copied from interface: `ServletRequest`
  Returns an array of `String` objects containing all of the values the given request parameter has, or `null` if the parameter does not exist.

  If the parameter has a single value, the array has a length of 1.

  Specified by:
    `getParameterValues` in interface `ServletRequest`
  Parameters:
    `name` - a `String` containing the name of the parameter whose value is requested
  Returns:
    an array of `String` objects containing the parameter's values
  See Also:
    `ServletRequest.getParameter(java.lang.String)`

### getPathInfo

    public java.lang.String getPathInfo()

  Description copied from interface: `HttpServletRequest`
  Returns any extra path information associated with the URL the client sent when it made this request. The extra path information follows the servlet path but precedes the query string and will start with a "/" character.

  This method returns `null` if there was no extra path information.

  Same as the value of the CGI variable PATH_INFO.

  Specified by:
    `getPathInfo` in interface `HttpServletRequest`
  Returns:
    a `String`, decoded by the web container, specifying extra path information that comes after the servlet path but before the query string in the request URL; or `null` if the URL does not have any extra path information

### getPathTranslated

    public java.lang.String getPathTranslated()

  Description copied from interface: `HttpServletRequest`
  Returns any extra path information after the servlet name but before the query string, and translates it to a real path. Same as the value of the CGI variable PATH_TRANSLATED.

  If the URL does not have any extra path information, this method returns `null` or the servlet container cannot translate the virtual path to a real path for any reason (such as when the web application is executed from an archive). The web container does not decode this string.

  Specified by:
    `getPathTranslated` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the real path, or `null` if the URL does not have any extra path information

### getProtocol

    public java.lang.String getProtocol()

  Description copied from interface: `ServletRequest`
  Returns the name and version of the protocol the request uses in the form protocol/majorVersion.minorVersion, for example, HTTP/1.1. For HTTP servlets, the value returned is the same as the value of the CGI variable `SERVER_PROTOCOL`.

  Specified by:
    `getProtocol` in interface `ServletRequest`
  Returns:
    a `String` containing the protocol name and version number

### getQueryEncoding

    public java.lang.String getQueryEncoding()

### getQueryString

    public java.lang.String getQueryString()

  Description copied from interface: `HttpServletRequest`
  Returns the query string that is contained in the request URL after the path. This method returns `null` if the URL does not have a query string. Same as the value of the CGI variable QUERY_STRING.

  Specified by:
    `getQueryString` in interface `HttpServletRequest`
  Returns:
    a `String` containing the query string or `null` if the URL contains no query string. The value is not decoded by the container.

### getReader

    public java.io.BufferedReader getReader()
                                     throws java.io.IOException

  Description copied from interface: `ServletRequest`
  Retrieves the body of the request as character data using a `BufferedReader`. The reader translates the character data according to the character encoding used on the body. Either this method or `ServletRequest.getInputStream()` may be called to read the body, not both.

  Specified by:
    `getReader` in interface `ServletRequest`
  Returns:
    a `BufferedReader` containing the body of the request
  Throws:
    `java.io.UnsupportedEncodingException` - if the character set encoding used is not supported and the text cannot be decoded
    `java.io.IOException` - if an input or output exception occurred
  See Also:
    `ServletRequest.getInputStream()`

### getRealPath

    public java.lang.String getRealPath(java.lang.String path)

  Specified by:
    `getRealPath` in interface `ServletRequest`

### getRemoteAddr

    public java.lang.String getRemoteAddr()

  Description copied from interface: `ServletRequest`
  Returns the Internet Protocol (IP) address of the client or last proxy that sent the request. For HTTP servlets, same as the value of the CGI variable `REMOTE_ADDR`.

  Specified by:
    `getRemoteAddr` in interface `ServletRequest`
  Returns:
    a `String` containing the IP address of the client that sent the request

### getRemoteHost

    public java.lang.String getRemoteHost()

  Description copied from interface: `ServletRequest`
  Returns the fully qualified name of the client or the last proxy that sent the request. If the engine cannot or chooses not to resolve the hostname (to improve performance), this method returns the dotted-string form of the IP address. For HTTP servlets, same as the value of the CGI variable `REMOTE_HOST`.

  Specified by:
    `getRemoteHost` in interface `ServletRequest`
  Returns:
    a `String` containing the fully qualified name of the client

### getRemotePort

    public int getRemotePort()

  Description copied from interface: `ServletRequest`
  Returns the Internet Protocol (IP) source port of the client or last proxy that sent the request.

  Specified by:
    `getRemotePort` in interface `ServletRequest`
  Returns:
    an integer specifying the port number

### getRemoteUser

    public java.lang.String getRemoteUser()

  Description copied from interface: `HttpServletRequest`
  Returns the login of the user making this request, if the user has been authenticated, or `null` if the user has not been authenticated. Whether the user name is sent with each subsequent request depends on the browser and type of authentication. Same as the value of the CGI variable REMOTE_USER.

  Specified by:
    `getRemoteUser` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the login of the user making this request, or `null` if the user login is not known

### getRequestDispatcher

    public RequestDispatcher getRequestDispatcher(java.lang.String path)

  Description copied from interface: `ServletRequest`
  Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path. A `RequestDispatcher` object can be used to forward a request to the resource or to include the resource in a response. The resource can be dynamic or static.

  The pathname specified may be relative, although it cannot extend outside the current servlet context. If the path begins with a "/" it is interpreted as relative to the current context root. This method returns `null` if the servlet container cannot return a `RequestDispatcher`.

  The difference between this method and `ServletContext.getRequestDispatcher(java.lang.String)` is that this method can take a relative path.

  Specified by:
    `getRequestDispatcher` in interface `ServletRequest`
  Parameters:
    `path` - a `String` specifying the pathname to the resource. If it is relative, it must be relative against the current servlet.
  Returns:
    a `RequestDispatcher` object that acts as a wrapper for the resource at the specified path, or `null` if the servlet container cannot return a `RequestDispatcher`
  See Also:
    `RequestDispatcher`, `ServletContext.getRequestDispatcher(java.lang.String)`

### getRequestedSessionId

    public java.lang.String getRequestedSessionId()

  Description copied from interface: `HttpServletRequest`
  Returns the session ID specified by the client. This may not be the same as the ID of the current valid session for this request. If the client did not specify a session ID, this method returns `null`.

  Specified by:
    `getRequestedSessionId` in interface `HttpServletRequest`
  Returns:
    a `String` specifying the session ID, or `null` if the request did not specify a session ID
  See Also:
    `HttpServletRequest.isRequestedSessionIdValid()`

### getRequestURI

    public java.lang.String getRequestURI()

  Description copied from interface: `HttpServletRequest`
  Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request. The web container does not decode this String. For example:

  First line of HTTP request | Returned Value
  --- | ---
  POST /some/path.html HTTP/1.1 |  | /some/path.html
  GET http://foo.bar/a.html HTTP/1.0 |  | /a.html
  HEAD /xyz?a=b HTTP/1.1 |  | /xyz

  To reconstruct an URL with a scheme and host, use `HttpUtils.getRequestURL(javax.servlet.http.HttpServletRequest)`.

  Specified by:
    `getRequestURI` in interface `HttpServletRequest`
  Returns:
    a `String` containing the part of the URL from the protocol name up to the query string
  See Also:
    `HttpUtils.getRequestURL(javax.servlet.http.HttpServletRequest)`

### getRequestURL

    public java.lang.StringBuffer getRequestURL()

  Description copied from interface: `HttpServletRequest`
  Reconstructs the URL the client used to make the request. The returned URL contains a protocol, server name, port number, and server path, but it does not include query string parameters.

  If this request has been forwarded using `RequestDispatcher.forward(javax.servlet.ServletRequest, javax.servlet.ServletResponse)`, the server path in the reconstructed URL must reflect the path used to obtain the RequestDispatcher, and not the server path specified by the client.

  Because this method returns a `StringBuffer`, not a string, you can modify the URL easily, for example, to append query parameters.

  This method is useful for creating redirect messages and for reporting errors.

  Specified by:
    `getRequestURL` in interface `HttpServletRequest`
  Returns:
    a `StringBuffer` object containing the reconstructed URL

### getResponse

    public Response getResponse()

### getRootURL

    public java.lang.StringBuilder getRootURL()

  Reconstructs the URL the client used to make the request. The returned URL contains a protocol, server name, port number, and, but it does not include a path.

  Because this method returns a `StringBuffer`, not a string, you can modify the URL easily, for example, to append path and query parameters. This method is useful for creating redirect messages and for reporting errors.

  Returns:
    "scheme://host:port"

### getScheme

    public java.lang.String getScheme()

  Description copied from interface: `ServletRequest`
  Returns the name of the scheme used to make this request, for example, `http`, `https`, or `ftp`. Different schemes have different rules for constructing URLs, as noted in RFC 1738.

  Specified by:
    `getScheme` in interface `ServletRequest`
  Returns:
    a `String` containing the name of the scheme used to make this request

### getServerName

    public java.lang.String getServerName()

  Description copied from interface: `ServletRequest`
  Returns the host name of the server to which the request was sent. It is the value of the part before ":" in the `Host` header value, if any, or the resolved server name, or the server IP address.

  Specified by:
    `getServerName` in interface `ServletRequest`
  Returns:
    a `String` containing the name of the server

### getServerPort

    public int getServerPort()

  Description copied from interface: `ServletRequest`
  Returns the port number to which the request was sent. It is the value of the part after ":" in the `Host` header value, if any, or the server port where the client connection was accepted on.

  Specified by:
    `getServerPort` in interface `ServletRequest`
  Returns:
    an integer specifying the port number

### getServletContext

    public ServletContext getServletContext()

  Description copied from interface: `ServletRequest`
  Gets the servlet context to which this ServletRequest was last dispatched.

  Specified by:
    `getServletContext` in interface `ServletRequest`
  Returns:
    the servlet context to which this ServletRequest was last dispatched

### getServletName

    public java.lang.String getServletName()

### getServletPath

    public java.lang.String getServletPath()

  Description copied from interface: `HttpServletRequest`
  Returns the part of this request's URL that calls the servlet. This path starts with a "/" character and includes either the servlet name or a path to the servlet, but does not include any extra path information or a query string. Same as the value of the CGI variable SCRIPT_NAME.

  This method will return an empty string ("") if the servlet used to process this request was matched using the "/*" pattern.

  Specified by:
    `getServletPath` in interface `HttpServletRequest`
  Returns:
    a `String` containing the name or path of the servlet being called, as specified in the request URL, decoded, or an empty string if the servlet used to process the request is matched using the "/*" pattern.

### getServletResponse

    public ServletResponse getServletResponse()

### getSession

    public HttpSession getSession()

  Description copied from interface: `HttpServletRequest`
  Returns the current session associated with this request, or if the request does not have a session, creates one.

  Specified by:
    `getSession` in interface `HttpServletRequest`
  Returns:
    the `HttpSession` associated with this request
  See Also:
    `HttpServletRequest.getSession(boolean)`

### getSession

    public HttpSession getSession(boolean create)

  Description copied from interface: `HttpServletRequest`
  Returns the current `HttpSession` associated with this request or, if there is no current session and `create` is true, returns a new session.

  If `create` is `false` and the request has no valid `HttpSession`, this method returns `null`.

  To make sure the session is properly maintained, you must call this method before the response is committed. If the container is using cookies to maintain session integrity and is asked to create a new session when the response is committed, an IllegalStateException is thrown.

  Specified by:
    `getSession` in interface `HttpServletRequest`
  Parameters:
    `create` - `true` to create a new session for this request if necessary; `false` to return `null` if there's no current session
  Returns:
    the `HttpSession` associated with this request or `null` if `create` is `false` and the request has no valid session
  See Also:
    `HttpServletRequest.getSession()`

### getSessionManager

    public SessionManager getSessionManager()

  Returns:
    Returns the sessionManager.

### getTimeStamp

    public long getTimeStamp()

  Get Request TimeStamp

  Returns:
    The time that the request was received.

### getTimeStampBuffer

    public Buffer getTimeStampBuffer()

  Get Request TimeStamp

  Returns:
    The time that the request was received.

### getUri

    public HttpURI getUri()

  Returns:
    Returns the uri.

### getUserIdentity

    public UserIdentity getUserIdentity()

### getResolvedUserIdentity

    public UserIdentity getResolvedUserIdentity()

  Returns:
    The resolved user Identity, which may be null if the `Authentication` is not `Authentication.User` (eg. `Authentication.Deferred`).

### getUserIdentityScope

    public UserIdentity.Scope getUserIdentityScope()

### getUserPrincipal

    public java.security.Principal getUserPrincipal()

  Description copied from interface: `HttpServletRequest`
  Returns a `java.security.Principal` object containing the name of the current authenticated user. If the user has not been authenticated, the method returns `null`.

  Specified by:
    `getUserPrincipal` in interface `HttpServletRequest`
  Returns:
    a `java.security.Principal` containing the name of the user making this request; `null` if the user has not been authenticated

### getDispatchTime

    public long getDispatchTime()

  Get timestamp of the request dispatch

  Returns:
    timestamp

### isAsyncStarted

    public boolean isAsyncStarted()

  Description copied from interface: `ServletRequest`
  Checks if this request has been put into asynchronous mode.

  A ServletRequest is put into asynchronous mode by calling `ServletRequest.startAsync()` or `ServletRequest.startAsync(ServletRequest,ServletResponse)` on it.

  This method returns `false` if this request was put into asynchronous mode, but has since been dispatched using one of the `AsyncContext.dispatch()` methods or released from asynchronous mode via a call to `AsyncContext.complete()`.

  Specified by:
    `isAsyncStarted` in interface `ServletRequest`
  Returns:
    true if this request has been put into asynchronous mode, false otherwise

### isAsyncSupported

    public boolean isAsyncSupported()

  Description copied from interface: `ServletRequest`
  Checks if this request supports asynchronous operation.

  Asynchronous operation is disabled for this request if this request is within the scope of a filter or servlet that has not been annotated or flagged in the deployment descriptor as being able to support asynchronous handling.

  Specified by:
    `isAsyncSupported` in interface `ServletRequest`
  Returns:
    true if this request supports asynchronous operation, false otherwise

### isHandled

    public boolean isHandled()

### isRequestedSessionIdFromCookie

    public boolean isRequestedSessionIdFromCookie()

  Description copied from interface: `HttpServletRequest`
  Checks whether the requested session ID came in as a cookie.

  Specified by:
    `isRequestedSessionIdFromCookie` in interface `HttpServletRequest`
  Returns:
    `true` if the session ID came in as a cookie; otherwise, `false`
  See Also:
    `HttpServletRequest.getSession(boolean)`

### isRequestedSessionIdFromUrl

    public boolean isRequestedSessionIdFromUrl()

  Specified by:
    `isRequestedSessionIdFromUrl` in interface `HttpServletRequest`

### isRequestedSessionIdFromURL

    public boolean isRequestedSessionIdFromURL()

  Description copied from interface: `HttpServletRequest`
  Checks whether the requested session ID came in as part of the request URL.

  Specified by:
    `isRequestedSessionIdFromURL` in interface `HttpServletRequest`
  Returns:
    `true` if the session ID came in as part of a URL; otherwise, `false`
  See Also:
    `HttpServletRequest.getSession(boolean)`

### isRequestedSessionIdValid

    public boolean isRequestedSessionIdValid()

  Description copied from interface: `HttpServletRequest`
  Checks whether the requested session ID is still valid.

  If the client did not specify any session ID, this method returns `false`.

  Specified by:
    `isRequestedSessionIdValid` in interface `HttpServletRequest`
  Returns:
    `true` if this request has an id for a valid session in the current session context; `false` otherwise
  See Also:
    `HttpServletRequest.getRequestedSessionId()`, `HttpServletRequest.getSession(boolean)`, `HttpSessionContext`

### isSecure

    public boolean isSecure()

  Description copied from interface: `ServletRequest`
  Returns a boolean indicating whether this request was made using a secure channel, such as HTTPS.

  Specified by:
    `isSecure` in interface `ServletRequest`
  Returns:
    a boolean indicating if the request was made using a secure channel

### isUserInRole

    public boolean isUserInRole(java.lang.String role)

  Description copied from interface: `HttpServletRequest`
  Returns a boolean indicating whether the authenticated user is included in the specified logical "role". Roles and role membership can be defined using deployment descriptors. If the user has not been authenticated, the method returns `false`.

  Specified by:
    `isUserInRole` in interface `HttpServletRequest`
  Parameters:
    `role` - a `String` specifying the name of the role
  Returns:
    a `boolean` indicating whether the user making this request belongs to a given role; `false` if the user has not been authenticated

### recoverNewSession

    public HttpSession recoverNewSession(java.lang.Object key)

### recycle

    protected void recycle()

### removeAttribute

    public void removeAttribute(java.lang.String name)

  Description copied from interface: `ServletRequest`
  Removes an attribute from this request. This method is not generally needed as attributes only persist as long as the request is being handled.

  Attribute names should follow the same conventions as package names. Names beginning with `java.*`, `javax.*`, and `com.sun.*`, are reserved for use by Sun Microsystems.

  Specified by:
    `removeAttribute` in interface `ServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the attribute to remove

### removeEventListener

    public void removeEventListener(java.util.EventListener listener)

### saveNewSession

    public void saveNewSession(java.lang.Object key,
                               HttpSession session)

### setAsyncSupported

    public void setAsyncSupported(boolean supported)

### setAttribute

    public void setAttribute(java.lang.String name,
                             java.lang.Object value)

  Description copied from interface: `ServletRequest`
  Stores an attribute in this request. Attributes are reset between requests. This method is most often used in conjunction with `RequestDispatcher`.

  Attribute names should follow the same conventions as package names. Names beginning with `java.*`, `javax.*`, and `com.sun.*`, are reserved for use by Sun Microsystems.
  If the object passed in is null, the effect is the same as calling `ServletRequest.removeAttribute(java.lang.String)`.
  It is warned that when the request is dispatched from the servlet resides in a different web application by `RequestDispatcher`, the object set by this method may not be correctly retrieved in the caller servlet.

  Specified by:
    `setAttribute` in interface `ServletRequest`
  Parameters:
    `name` - a `String` specifying the name of the attribute
    `value` - the `Object` to be stored

### setAttributes

    public void setAttributes(Attributes attributes)

### setAuthentication

    public void setAuthentication(Authentication authentication)

  Set the authentication.

  Parameters:
    `authentication` - the authentication to set

### setCharacterEncoding

    public void setCharacterEncoding(java.lang.String encoding)
                              throws java.io.UnsupportedEncodingException

  Description copied from interface: `ServletRequest`
  Overrides the name of the character encoding used in the body of this request. This method must be called prior to reading request parameters or reading input using getReader(). Otherwise, it has no effect.

  Specified by:
    `setCharacterEncoding` in interface `ServletRequest`
  Parameters:
    `encoding` - `String` containing the name of the character encoding.
  Throws:
    `java.io.UnsupportedEncodingException` - if this ServletRequest is still in a state where a character encoding may be set, but the specified encoding is invalid

### setCharacterEncodingUnchecked

    public void setCharacterEncodingUnchecked(java.lang.String encoding)

### setConnection

    protected final void setConnection(HttpConnection connection)

### setContentType

    public void setContentType(java.lang.String contentType)

### setContext

    public void setContext(ContextHandler.Context context)

  Set request context

  Parameters:
    `context` - context object

### takeNewContext

    public boolean takeNewContext()

  Returns:
    True if this is the first call of `takeNewContext()` since the last `setContext(org.eclipse.jetty.server.handler.ContextHandler.Context)` call.

### setContextPath

    public void setContextPath(java.lang.String contextPath)

  Sets the "context path" for this request

  See Also:
    `HttpServletRequest.getContextPath()`

### setCookies

    public void setCookies(Cookie[] cookies)

  Parameters:
    `cookies` - The cookies to set.

### setDispatcherType

    public void setDispatcherType(DispatcherType type)

### setHandled

    public void setHandled(boolean h)

### setMethod

    public void setMethod(java.lang.String method)

  Parameters:
    `method` - The method to set.

### setParameters

    public void setParameters(MultiMap<java.lang.String> parameters)

  Parameters:
    `parameters` - The parameters to set.

### setPathInfo

    public void setPathInfo(java.lang.String pathInfo)

  Parameters:
    `pathInfo` - The pathInfo to set.

### setProtocol

    public void setProtocol(java.lang.String protocol)

  Parameters:
    `protocol` - The protocol to set.

### setQueryEncoding

    public void setQueryEncoding(java.lang.String queryEncoding)

  Set the character encoding used for the query string. This call will effect the return of getQueryString and getParamaters. It must be called before any geParameter methods. The request attribute "org.eclipse.jetty.server.server.Request.queryEncoding" may be set as an alternate method of calling setQueryEncoding.

  Parameters:
    `queryEncoding` -

### setQueryString

    public void setQueryString(java.lang.String queryString)

  Parameters:
    `queryString` - The queryString to set.

### setRemoteAddr

    public void setRemoteAddr(java.lang.String addr)

  Parameters:
    `addr` - The address to set.

### setRemoteHost

    public void setRemoteHost(java.lang.String host)

  Parameters:
    `host` - The host to set.

### setRequestedSessionId

    public void setRequestedSessionId(java.lang.String requestedSessionId)

  Parameters:
    `requestedSessionId` - The requestedSessionId to set.

### setRequestedSessionIdFromCookie

    public void setRequestedSessionIdFromCookie(boolean requestedSessionIdCookie)

  Parameters:
    `requestedSessionIdCookie` - The requestedSessionIdCookie to set.

### setRequestURI

    public void setRequestURI(java.lang.String requestURI)

  Parameters:
    `requestURI` - The requestURI to set.

### setScheme

    public void setScheme(java.lang.String scheme)

  Parameters:
    `scheme` - The scheme to set.

### setServerName

    public void setServerName(java.lang.String host)

  Parameters:
    `host` - The host to set.

### setServerPort

    public void setServerPort(int port)

  Parameters:
    `port` - The port to set.

### setServletPath

    public void setServletPath(java.lang.String servletPath)

  Parameters:
    `servletPath` - The servletPath to set.

### setSession

    public void setSession(HttpSession session)

  Parameters:
    `session` - The session to set.

### setSessionManager

    public void setSessionManager(SessionManager sessionManager)

  Parameters:
    `sessionManager` - The sessionManager to set.

### setTimeStamp

    public void setTimeStamp(long ts)

### setUri

    public void setUri(HttpURI uri)

  Parameters:
    `uri` - The uri to set.

### setUserIdentityScope

    public void setUserIdentityScope(UserIdentity.Scope scope)

### setDispatchTime

    public void setDispatchTime(long value)

  Set timetstamp of request dispatch

  Parameters:
    `value` - timestamp

### startAsync

    public AsyncContext startAsync()
                            throws java.lang.IllegalStateException

  Description copied from interface: `ServletRequest`
  Puts this request into asynchronous mode, and initializes its `AsyncContext` with the original (unwrapped) ServletRequest and ServletResponse objects.

  Calling this method will cause committal of the associated response to be delayed until `AsyncContext.complete()` is called on the returned `AsyncContext`, or the asynchronous operation has timed out.

  Calling `AsyncContext.hasOriginalRequestAndResponse()` on the returned AsyncContext will return `true`. Any filters invoked in the outbound direction after this request was put into asynchronous mode may use this as an indication that any request and/or response wrappers that they added during their inbound invocation need not stay around for the duration of the asynchronous operation, and therefore any of their associated resources may be released.

  This method clears the list of `AsyncListener` instances (if any) that were registered with the AsyncContext returned by the previous call to one of the startAsync methods, after calling each AsyncListener at its `onStartAsync` method.

  Subsequent invocations of this method, or its overloaded variant, will return the same AsyncContext instance, reinitialized as appropriate.

  Specified by:
    `startAsync` in interface `ServletRequest`
  Returns:
    the (re)initialized AsyncContext
  Throws:
    `java.lang.IllegalStateException` - if this request is within the scope of a filter or servlet that does not support asynchronous operations (that is, `ServletRequest.isAsyncSupported()` returns false), or if this method is called again without any asynchronous dispatch (resulting from one of the `AsyncContext.dispatch()` methods), is called outside the scope of any such dispatch, or is called again within the scope of the same dispatch, or if the response has already been closed

### startAsync

    public AsyncContext startAsync(ServletRequest servletRequest,
                                   ServletResponse servletResponse)
                            throws java.lang.IllegalStateException

  Description copied from interface: `ServletRequest`
  Puts this request into asynchronous mode, and initializes its `AsyncContext` with the given request and response objects.

  The ServletRequest and ServletResponse arguments must be the same instances, or instances of `ServletRequestWrapper` and `ServletResponseWrapper` that wrap them, that were passed to the `service` method of the Servlet or the `doFilter` method of the Filter, respectively, in whose scope this method is being called.

  Calling this method will cause committal of the associated response to be delayed until `AsyncContext.complete()` is called on the returned `AsyncContext`, or the asynchronous operation has timed out.

  Calling `AsyncContext.hasOriginalRequestAndResponse()` on the returned AsyncContext will return `false`, unless the passed in ServletRequest and ServletResponse arguments are the original ones or do not carry any application-provided wrappers. Any filters invoked in the outbound direction after this request was put into asynchronous mode may use this as an indication that some of the request and/or response wrappers that they added during their inbound invocation may need to stay in place for the duration of the asynchronous operation, and their associated resources may not be released. A ServletRequestWrapper applied during the inbound invocation of a filter may be released by the outbound invocation of the filter only if the given `servletRequest`, which is used to initialize the AsyncContext and will be returned by a call to `AsyncContext.getRequest()`, does not contain said ServletRequestWrapper. The same holds true for ServletResponseWrapper instances.

  This method clears the list of `AsyncListener` instances (if any) that were registered with the AsyncContext returned by the previous call to one of the startAsync methods, after calling each AsyncListener at its `onStartAsync` method.

  Subsequent invocations of this method, or its zero-argument variant, will return the same AsyncContext instance, reinitialized as appropriate. If a call to this method is followed by a call to its zero-argument variant, the specified (and possibly wrapped) request and response objects will remain locked in on the returned AsyncContext.

  Specified by:
    `startAsync` in interface `ServletRequest`
  Parameters:
    `servletRequest` - the ServletRequest used to initialize the AsyncContext
    `servletResponse` - the ServletResponse used to initialize the AsyncContext
  Returns:
    the (re)initialized AsyncContext
  Throws:
    `java.lang.IllegalStateException` - if this request is within the scope of a filter or servlet that does not support asynchronous operations (that is, `ServletRequest.isAsyncSupported()` returns false), or if this method is called again without any asynchronous dispatch (resulting from one of the `AsyncContext.dispatch()` methods), is called outside the scope of any such dispatch, or is called again within the scope of the same dispatch, or if the response has already been closed

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### authenticate

    public boolean authenticate(HttpServletResponse response)
                         throws java.io.IOException,
                                ServletException

  Description copied from interface: `HttpServletRequest`
  Use the container login mechanism configured for the `ServletContext` to authenticate the user making this request.

  This method may modify and commit the argument `HttpServletResponse`.

  Specified by:
    `authenticate` in interface `HttpServletRequest`
  Parameters:
    `response` - The `HttpServletResponse` associated with this `HttpServletRequest`
  Returns:
    `true` when non-null values were or have been established as the values returned by `getUserPrincipal`, `getRemoteUser`, and `getAuthType`. Return `false` if authentication is incomplete and the underlying login mechanism has committed, in the response, the message (e.g., challenge) and HTTP status code to be returned to the user.
  Throws:
    `java.io.IOException` - if an input or output error occurred while reading from this request or writing to the given response
    `ServletException` - if the authentication failed and the caller is responsible for handling the error (i.e., the underlying login mechanism did NOT establish the message and HTTP status code to be returned to the user)

### getPart

    public Part getPart(java.lang.String name)
                 throws java.io.IOException,
                        ServletException

  Description copied from interface: `HttpServletRequest`
  Gets the `Part` with the given name.

  Specified by:
    `getPart` in interface `HttpServletRequest`
  Parameters:
    `name` - the name of the requested Part
  Returns:
    The Part with the given name, or `null` if this request is of type `multipart/form-data`, but does not contain the requested Part
  Throws:
    `java.io.IOException` - if an I/O error occurred during the retrieval of the requested Part
    `ServletException` - if this request is not of type `multipart/form-data`
  See Also:
    `MultipartConfig.maxFileSize()`, `MultipartConfig.maxRequestSize()`

### getParts

    public java.util.Collection<Part> getParts()
                                        throws java.io.IOException,
                                               ServletException

  Description copied from interface: `HttpServletRequest`
  Gets all the `Part` components of this request, provided that it is of type `multipart/form-data`.

  If this request is of type `multipart/form-data`, but does not contain any Part components, the returned `Collection` will be empty.

  Any changes to the returned `Collection` must not affect this `HttpServletRequest`.

  Specified by:
    `getParts` in interface `HttpServletRequest`
  Returns:
    a (possibly empty) `Collection` of the Part components of this request
  Throws:
    `java.io.IOException` - if an I/O error occurred during the retrieval of the `Part` components of this request
    `ServletException` - if this request is not of type `multipart/form-data`
  See Also:
    `MultipartConfig.maxFileSize()`, `MultipartConfig.maxRequestSize()`

### login

    public void login(java.lang.String username,
                      java.lang.String password)
               throws ServletException

  Description copied from interface: `HttpServletRequest`
  Validate the provided username and password in the password validation realm used by the web container login mechanism configured for the `ServletContext`.

  This method returns without throwing a `ServletException` when the login mechanism configured for the `ServletContext` supports username password validation, and when, at the time of the call to login, the identity of the caller of the request had not been established (i.e, all of `getUserPrincipal`, `getRemoteUser`, and `getAuthType` return null), and when validation of the provided credentials is successful. Otherwise, this method throws a `ServletException` as described below.

  When this method returns without throwing an exception, it must have established non-null values as the values returned by `getUserPrincipal`, `getRemoteUser`, and `getAuthType`.

  Specified by:
    `login` in interface `HttpServletRequest`
  Parameters:
    `username` - The `String` value corresponding to the login identifier of the user.
    `password` - The password `String` corresponding to the identified user.
  Throws:
    `ServletException` - if the configured login mechanism does not support username password authentication, or if a non-null caller identity had already been established (prior to the call to login), or if validation of the provided username and password fails.

### logout

    public void logout()
                throws ServletException

  Description copied from interface: `HttpServletRequest`
  Establish `null` as the value returned when `getUserPrincipal`, `getRemoteUser`, and `getAuthType` is called on the request.

  Specified by:
    `logout` in interface `HttpServletRequest`
  Throws:
    `ServletException` - if logout fails

### mergeQueryString

    public void mergeQueryString(java.lang.String query)

  Merge in a new query string. The query string is merged with the existing parameters and `setParameters(MultiMap)` and `setQueryString(String)` are called with the result. The merge is according to the rules of the servlet dispatch forward method.

  Parameters:
    `query` - The query string to merge into the request.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1995-2010 Mort Bay Consulting. All Rights Reserved.